package pro.litvinovg.libreoffice;

import java.util.ArrayList;

import com.sun.star.beans.UnknownPropertyException;
import com.sun.star.beans.XPropertySet;
import com.sun.star.lang.WrappedTargetException;
import com.sun.star.text.XText;
import com.sun.star.text.XTextContent;
import com.sun.star.text.XTextRange;
import com.sun.star.uno.UnoRuntime;
import pro.litvinovg.libreoffice.metadata.OutlineElement;
import static pro.litvinovg.libreoffice.metadata.Document.*; 


public class MetadataReader extends DocumentParserImpl {
	private ArrayList<OutlineElement> outline;
	private boolean firstPara = true;
	
	public MetadataReader(XText text, ArrayList<OutlineElement> outline) {
		super(text);
		this.outline = outline;
	}
	@Override
	public void parse() {
		parseText(text);
  	OutlineElement lastElement = outline.get(outline.size()-1);
	}
	
	@Override
	public void portionProperties(XPropertySet portionPoperties, XTextContent textContent) {
		String portionType = null;
		try {
			portionType = (String) portionPoperties.getPropertyValue("TextPortionType");
			if (portionType != null && portionType.equals("Annotation")) {
				Object annotation = portionPoperties.getPropertyValue("TextField");
	      XPropertySet annotationProperties = UnoRuntime.queryInterface(XPropertySet.class, annotation);
	    	String author = (String) annotationProperties.getPropertyValue("Author");
	      if (author != null && author.equals(METADATA_EXTENSION)) {
	      	String content = (String) annotationProperties.getPropertyValue("Content");
	      	OutlineElement lastElement = outline.get(outline.size()-1);
	      	lastElement.readMetadata(content);
	      }
			}
		} catch (UnknownPropertyException e) {
			e.printStackTrace();
		} catch (WrappedTargetException e) {
			e.printStackTrace();
		}
	}
	
	@Override
	protected void paraProperties(XPropertySet properties, XTextContent textContent) {
		Short outlineLevel = null;
		try {
			outlineLevel = (Short) properties.getPropertyValue("OutlineLevel");
		} catch (UnknownPropertyException e) {
			e.printStackTrace();
		} catch (WrappedTargetException e) {
			e.printStackTrace();
		}
		if (firstPara || (outlineLevel != null && outlineLevel > 0)) {
			XTextRange textRange = textContent.getAnchor();
			if (firstPara) {
				outline.add(new OutlineElement(textRange,  "Документ"));
				firstPara = false;
			} else {
				outline.add(new OutlineElement(textRange,  textRange.getString()));	
			}
		}
	}
}
